/*
--------------------------------------------------------------------------------
containers
--------------------------------------------------------------------------------
containers can contain any item. containers are items.
*/
var item = []; // master item list;

class Item {
	constructor(name) {
		if (name == undefined)
			name = "item";
		this.name = name;
		this.type = "item";
		this.known = false;
		if (arguments.length > 1) { // if description is passed in
			this.description = arguments[1];
		}

		// project specific- remove this
		// add to central list
		item.push(this);
	}
}

// once known, "room" becomes "reflecting pool"
// once known, "door" becomes "door with tern carving"

// first argument is name, later arguments are contents? is that nice?
// new Container("box", apple, apple);
// maybe not, maybe just do the name?
class Container extends Item {
	constructor(name) {
		super();
		if (name == undefined)
			name = "container";
		this.name = name;
		this.type = "container";
		this.contents = [];
		if (arguments.length > 1) { // if description is passed in
			this.description = arguments[1];
		}
		// if (arguments.length > 1) { // if contents are passed in
		// 	for (let i = 1; i < arguments.length; i ++) {
		// 		this.contents.push(arguments[i]);
		// 	}
		// }
	}

	contains(target) {
		this.contents.push(target);
		// we could add protection against redundant adds
	}
}


// a two way door?
// how would carrying these work, are they actually two door linked door objects?
class Door {
	constructor(name, room) {
		this.name = name;
		this.type = "door";
		// there are compelling arguments for parent container management
		// for now let's do a special case: doors store parents 
		this.twin = undefined;
		this.parent = room;

		// when you go through a door, what you actually do is look up the other door on the other end, and get its parent, then go there

		if (arguments.length > 2) { // if description is passed in
			this.description = arguments[1];
		}
		debugger;
	}
}


// maybe make these in pairs, link them to each other (but not the destination room)
// pass in two rooms. this makes two joined doors (in the rooms)
const connect = (rooma, roomb) => {
	let a = new Door("door a", rooma);
	let b = new Door("door b", roomb);
	a.twin = b;
	b.twin = a;
	rooma.contains(a);
	roomb.contains(b);
}


/*
--------------------------------------------------------------------------------
not really testing anymore
--------------------------------------------------------------------------------
*/


const indent = "-     ";
const divider = "---------------------------------------------------\<\/br\>";
const linebreak = "<br>";

const printcontainer = (container) => {
	let known = container.known;
	
	// first make a list
	visibleitem = [];
	for (let current of container.contents) {
		if ((current.hidden == undefined) || (current.hidden == false))
			visibleitem.push(current);
	}

	if (known) {
		print("\<b\>" + container.name + "\<\/b\>");
		for (let item of visibleitem) {
			if (item.hidden == true) {
				// print("-");
			}
			else {
				if (item.contents == undefined) // not a container
					print(indent + "\<b\>\<i\>" + item.name + "\<\/b\>\<\/i\>");
				else {
					// fork based on whether the room is known or not
					let name = "";
					if (item.known) {
						name = "\<b\>\<i\>" + item.name + "\<\/b\>\<\/i\>";
					}
					else {
						name = "\<i\>" + "unknown room" + "\<\/i\>";
					}
					print(indent + "door to " + name);
				}
			}
		}
	}
	else {
		print("\<b\>" + "\<i\>" + "room" + "\<\/i\>" + "\<\/b\>");
		// print("this door leads to an " + "\<b\>" + "\<i\>" + "unknown room" + "\<\/i\>" + "\<\/b\>");

		// print("(~ to look around)");
		// print("(~)");
	}

	// question: how do doors work? you can put another room directly inside of a container, which makes it navigable, however the display name is strange because it uses the known name
}


const look = (item) => {
	if (item.description != undefined) {
		print("");
		print(container.description);		
		print("");
	}
}

const testContainers = () => {


	//--------------------------------------------------------------------------
	//rooms
	//--------------------------------------------------------------------------

	let pool = new Item("pool");
	pool.description = "it is hard to imagine a world so rich that water could be used for decoration";

	let floor = new Item("floor");
	floor.description = "there are telltale angular artifacts at the corners: it is likely a track worn by one of the room's guardians, assigned the task of honoring the pool. it will be a shame to mar the surface with irrigation channels.";

	let reflectingpool = new Container("reflecting pool");
	reflectingpool.description = "a still place, once used for quiet conversation or solitary contemplation. the pool runs the length of the long room. the ground around the reflecting pool has been polished, as if an object were repeatedly dragged around it in a perfect rectangle."
	reflectingpool.contains(pool);
	reflectingpool.contains(floor);

	printContainer(reflectingpool);
}